// This file is generated by kconfig_compiler from ktorrent.kcfg.
// All changes you do to this file will be lost.
#ifndef SETTINGS_H
#define SETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

class Settings : public KConfigSkeleton
{
  public:

    static Settings *self();
    ~Settings();

    /**
      Set Maximum number of downloads (0 = no limit)
    */
    static
    void setMaxDownloads( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxDownloads: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxDownloads" ) ))
        self()->mMaxDownloads = v;
    }

    /**
      Get Maximum number of downloads (0 = no limit)
    */
    static
    int maxDownloads()
    {
      return self()->mMaxDownloads;
    }

    /**
      Set Maximum number of seeds (0 = no limit)
    */
    static
    void setMaxSeeds( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxSeeds: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxSeeds" ) ))
        self()->mMaxSeeds = v;
    }

    /**
      Get Maximum number of seeds (0 = no limit)
    */
    static
    int maxSeeds()
    {
      return self()->mMaxSeeds;
    }

    /**
      Set Maximum number of connections per download (0 = no limit)
    */
    static
    void setMaxConnections( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxConnections: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxConnections" ) ))
        self()->mMaxConnections = v;
    }

    /**
      Get Maximum number of connections per download (0 = no limit)
    */
    static
    int maxConnections()
    {
      return self()->mMaxConnections;
    }

    /**
      Set Maximum upload speed in KB/sec (0 = no limit)
    */
    static
    void setMaxUploadRate( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxUploadRate: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxUploadRate" ) ))
        self()->mMaxUploadRate = v;
    }

    /**
      Get Maximum upload speed in KB/sec (0 = no limit)
    */
    static
    int maxUploadRate()
    {
      return self()->mMaxUploadRate;
    }

    /**
      Set Maximum download speed in KB/sec (0 = no limit)
    */
    static
    void setMaxDownloadRate( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setMaxDownloadRate: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1( "maxDownloadRate" ) ))
        self()->mMaxDownloadRate = v;
    }

    /**
      Get Maximum download speed in KB/sec (0 = no limit)
    */
    static
    int maxDownloadRate()
    {
      return self()->mMaxDownloadRate;
    }

    /**
      Set Port
    */
    static
    void setPort( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setPort: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > 65535)
      {
        kdDebug() << "setPort: value " << v << " is greater than the maximum value of 65535" << endl;
        v = 65535;
      }

      if (!self()->isImmutable( QString::fromLatin1( "port" ) ))
        self()->mPort = v;
    }

    /**
      Get Port
    */
    static
    int port()
    {
      return self()->mPort;
    }

    /**
      Set Port
    */
    static
    void setUdpTrackerPort( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setUdpTrackerPort: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > 65535)
      {
        kdDebug() << "setUdpTrackerPort: value " << v << " is greater than the maximum value of 65535" << endl;
        v = 65535;
      }

      if (!self()->isImmutable( QString::fromLatin1( "udpTrackerPort" ) ))
        self()->mUdpTrackerPort = v;
    }

    /**
      Get Port
    */
    static
    int udpTrackerPort()
    {
      return self()->mUdpTrackerPort;
    }

    /**
      Set Show a system tray icon
    */
    static
    void setShowSystemTrayIcon( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "showSystemTrayIcon" ) ))
        self()->mShowSystemTrayIcon = v;
    }

    /**
      Get Show a system tray icon
    */
    static
    bool showSystemTrayIcon()
    {
      return self()->mShowSystemTrayIcon;
    }

    /**
      Set Keep seeding after download has finished
    */
    static
    void setKeepSeeding( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "keepSeeding" ) ))
        self()->mKeepSeeding = v;
    }

    /**
      Get Keep seeding after download has finished
    */
    static
    bool keepSeeding()
    {
      return self()->mKeepSeeding;
    }

    /**
      Set Folder to store temporary files
    */
    static
    void setTempDir( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "tempDir" ) ))
        self()->mTempDir = v;
    }

    /**
      Get Folder to store temporary files
    */
    static
    QString tempDir()
    {
      return self()->mTempDir;
    }

    /**
      Set Whether to automatically save downloads to saveDir
    */
    static
    void setUseSaveDir( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "useSaveDir" ) ))
        self()->mUseSaveDir = v;
    }

    /**
      Get Whether to automatically save downloads to saveDir
    */
    static
    bool useSaveDir()
    {
      return self()->mUseSaveDir;
    }

    /**
      Set Folder to store downloaded files
    */
    static
    void setSaveDir( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "saveDir" ) ))
        self()->mSaveDir = v;
    }

    /**
      Get Folder to store downloaded files
    */
    static
    QString saveDir()
    {
      return self()->mSaveDir;
    }

    /**
      Set Whether to use a custom IP to pass to the tracker
    */
    static
    void setUseExternalIP( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "useExternalIP" ) ))
        self()->mUseExternalIP = v;
    }

    /**
      Get Whether to use a custom IP to pass to the tracker
    */
    static
    bool useExternalIP()
    {
      return self()->mUseExternalIP;
    }

    /**
      Set IP to pass to the tracker
    */
    static
    void setExternalIP( const QString & v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "externalIP" ) ))
        self()->mExternalIP = v;
    }

    /**
      Get IP to pass to the tracker
    */
    static
    QString externalIP()
    {
      return self()->mExternalIP;
    }

    /**
      Set Memory usage
    */
    static
    void setMemoryUsage( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "memoryUsage" ) ))
        self()->mMemoryUsage = v;
    }

    /**
      Get Memory usage
    */
    static
    int memoryUsage()
    {
      return self()->mMemoryUsage;
    }

    /**
      Set GUI update interval
    */
    static
    void setGuiUpdateInterval( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "guiUpdateInterval" ) ))
        self()->mGuiUpdateInterval = v;
    }

    /**
      Get GUI update interval
    */
    static
    int guiUpdateInterval()
    {
      return self()->mGuiUpdateInterval;
    }

    /**
      Set Support for DHT
    */
    static
    void setDhtSupport( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "dhtSupport" ) ))
        self()->mDhtSupport = v;
    }

    /**
      Get Support for DHT
    */
    static
    bool dhtSupport()
    {
      return self()->mDhtSupport;
    }

    /**
      Set DHT port
    */
    static
    void setDhtPort( int v )
    {
      if (v < 0)
      {
        kdDebug() << "setDhtPort: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }

      if (v > 65535)
      {
        kdDebug() << "setDhtPort: value " << v << " is greater than the maximum value of 65535" << endl;
        v = 65535;
      }

      if (!self()->isImmutable( QString::fromLatin1( "dhtPort" ) ))
        self()->mDhtPort = v;
    }

    /**
      Get DHT port
    */
    static
    int dhtPort()
    {
      return self()->mDhtPort;
    }

    /**
      Set Number of upload slots
    */
    static
    void setNumUploadSlots( int v )
    {
      if (v < 4)
      {
        kdDebug() << "setNumUploadSlots: value " << v << " is less than the minimum value of 4" << endl;
        v = 4;
      }

      if (v > 100)
      {
        kdDebug() << "setNumUploadSlots: value " << v << " is greater than the maximum value of 100" << endl;
        v = 100;
      }

      if (!self()->isImmutable( QString::fromLatin1( "numUploadSlots" ) ))
        self()->mNumUploadSlots = v;
    }

    /**
      Get Number of upload slots
    */
    static
    int numUploadSlots()
    {
      return self()->mNumUploadSlots;
    }

    /**
      Set Use protocol encryption
    */
    static
    void setUseEncryption( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "useEncryption" ) ))
        self()->mUseEncryption = v;
    }

    /**
      Get Use protocol encryption
    */
    static
    bool useEncryption()
    {
      return self()->mUseEncryption;
    }

    /**
      Set Allow unencrypted connections
    */
    static
    void setAllowUnencryptedConnections( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1( "allowUnencryptedConnections" ) ))
        self()->mAllowUnencryptedConnections = v;
    }

    /**
      Get Allow unencrypted connections
    */
    static
    bool allowUnencryptedConnections()
    {
      return self()->mAllowUnencryptedConnections;
    }

    static
    void writeConfig()
    {
      static_cast<KConfigSkeleton*>(self())->writeConfig();
    }
  protected:
    Settings();
    static Settings *mSelf;


    // downloads
    int mMaxDownloads;
    int mMaxSeeds;
    int mMaxConnections;
    int mMaxUploadRate;
    int mMaxDownloadRate;
    int mPort;
    int mUdpTrackerPort;
    bool mShowSystemTrayIcon;
    bool mKeepSeeding;
    QString mTempDir;
    bool mUseSaveDir;
    QString mSaveDir;
    bool mUseExternalIP;
    QString mExternalIP;
    int mMemoryUsage;
    int mGuiUpdateInterval;
    bool mDhtSupport;
    int mDhtPort;
    int mNumUploadSlots;
    bool mUseEncryption;
    bool mAllowUnencryptedConnections;

  private:
};

#endif

